/*
 * e_cu.c
 *
 *  Created on: 24-06-2016
 *      Author: Krzysztof Jakubczyk
 *
 *      Wylicza calke oznaczona napiecia w nastawionym oknie czasowym
 *
 *
 */

#include "tdefs.h"
#include "misc.h"

#include "e_cu.h"
#include "e_mem1.h"
#include <math.h>

int e_cu_initlog(void *arguments, void *logic)
{
	struct e_cu_args *args = (struct e_cu_args *)arguments;
	struct e_cu_logic *log = (struct e_cu_logic *)logic;

	u32 *buf_ptr;

	log->esk_ptr = (float *)(log_manager.nets_data + (args->io.esk_float_out >> 3));
	if((u8 *)log->esk_ptr > (log_manager.nets_data+sizeof(log_manager.nets_data) - sizeof(float)))
		return -1;

	buf_ptr = (u32 *)(log_manager.nets_data + (args->io.buf_ptr_in >> 3));
	if((u8*)buf_ptr > (log_manager.nets_data+sizeof(log_manager.nets_data) - sizeof(void *)))
		return -1;

	log->we = (struct e_mem1_wyjscie *)*buf_ptr;

	log->ok_ptr = log_manager.nets_data + (args->io.ok_out >> 3);
	log->ok_bit_no = args->io.ok_out & 0x07;

	if(log->ok_ptr >= (log_manager.nets_data+sizeof(log_manager.nets_data)))
		return -1;

    if ((int16_t)(args->params.czas_ - 16) % 2)
	{
	    log->zakres_ = od16do30_nieparzyste;
	} else
	{
	    log->zakres_ = od16do30_parzyste;
	}

    // wyliczanie polozenia wlasciwych wartosci w pamieci
    log->ofset_ = (int16_t)((args->params.czas_ -16) / 0.4);

    if(args->params.czas_ < 16)
    {
        log->zakres_ = od8do16;
        log->ofset_ = (int16_t)((args->params.czas_ - 8) / 0.2);
    }

    if(args->params.czas_ < 8)
    {
        log->zakres_ = od4do8;
        log->ofset_ = (int16_t)((args->params.czas_ - 4) / 0.1);
    }

    if(args->params.czas_ < 4)
    {
        log->zakres_ = mniej4;
        log->ofset_ = (int16_t)(args->params.czas_ / 0.05);
    }

	log->czas = (int16_t)(100 * args->params.czas_);
	log->Ubl_ = args->params.Ubl_;

	if(args->params.bity & 0x0001)
		log->Uwe =  1;
	else
		log->Uwe = 0.57735; //jeden przez pierwiastek z 3
    //

	return 0;
}

void e_cu_20hz(void *arguments, void *logic)
{
	struct e_cu_logic *log = (struct e_cu_logic *)logic;
	struct e_mem1_wyjscie *w = log->we;

    short temp;
    float temp2,temp3;
    int i;
	u8 OK;

    temp2 = 0;
    temp3 = 0;

	if (w->czas_>=log->czas) OK = 1; else OK = 0;

    switch(log->zakres_)// wyliczanie w zaleznosci od zakresu nastawy czasu
    {
        case mniej4:
            temp = w->idx_50ms_ - log->ofset_; // wyliczenie indeksu tablicy dla danej chwili czasu
            if(temp<0) temp += 80; // uwzglednienie "przekrecania" bufora"
            //wyliczenie calki za czas nastawiony
            while(temp!=w->idx_50ms_)
            {
                temp++;
                if(temp>79) temp = 0;
                temp2 += w->srednia_50ms_[temp];
				if (w->srednia_50ms_[temp] < log->Ubl_) OK = 0;
            }
            temp2 /= log->ofset_;
            //
            break;
        case od4do8:
            temp = w->idx_100ms_ - log->ofset_;// wyliczenie indeksu tablicy dla danej chwili czasu
            if(temp<0) temp += 40;// uwzglednienie "przekrecania" bufora"
            for (i=0;i<80;i++)
			{
				temp3 += w->srednia_50ms_[i];//wyliczanie calki za czas od 0-4s;
				if (w->srednia_50ms_[temp] < log->Ubl_) OK = 0;
			}
            temp2 = temp3 / 2;
            //doliczenie calki za czesc czasu z zakresu powyzej 4s
            temp3 = 0;
            while(temp!=w->idx_100ms_)
            {
                temp++;
                if(temp>39) temp = 0;
                temp3 += w->srednia_100ms_[temp];
				if (w->srednia_100ms_[temp] < log->Ubl_) OK = 0;
            }
            temp2 += temp3;
            temp2 /= 40 + log->ofset_; // calka za caly czas okna pomiarowego
            //
            break;
        case od8do16:
            temp = w->idx_200ms_ - log->ofset_;// wyliczenie indeksu tablicy dla danej chwili czasu
            if(temp<0) temp += 40;// uwzglednienie "przekrecania" bufora"
            for (i=0;i<80;i++)
			{
				temp3 += w->srednia_50ms_[i];//wyliczanie calki za czas od 0-4s;
				if (w->srednia_50ms_[temp] < log->Ubl_) OK = 0;
			}
            temp2 = temp3 / 4;
            temp3 = 0;
            for (i=0;i<40;i++)
			{
				temp3 += w->srednia_100ms_[i];//wyliczanie calki za czas od 4-8s;
				if (w->srednia_100ms_[temp] < log->Ubl_) OK = 0;
			}
            temp2 += temp3 / 2;
            //doliczenie calki za czesc czasu z zakresu powyzej 8s
            temp3 = 0;
            while(temp!=w->idx_200ms_)
            {
                temp++;
                if(temp>39) temp = 0;
                temp3 += w->srednia_200ms_[temp];
				if (w->srednia_200ms_[temp] < log->Ubl_) OK = 0;
            }
            temp2 += temp3;
            temp2 /= 40 + log->ofset_; // calka za caly czas okna pomiarowego
            //
            break;
        case od16do30_parzyste:
        case od16do30_nieparzyste:
            temp = w->idx_400ms_ - log->ofset_;// wyliczenie indeksu tablicy dla danej chwili czasu
            if(temp<0) temp += 36;// uwzglednienie "przekrecania" bufora"
            for (i=0;i<80;i++)
			{
				temp3 += w->srednia_50ms_[i];//wyliczanie calki za czas od 0-4s;
				if (w->srednia_50ms_[temp] < log->Ubl_) OK = 0;
			}
            temp2 = temp3 / 8;
            temp3 = 0;
            for (i=0;i<40;i++)
			{
				temp3 += w->srednia_100ms_[i];//wyliczanie calki za czas od 4-8s;
				if (w->srednia_100ms_[temp] < log->Ubl_) OK = 0;
			}
            temp2 += temp3 / 4;
            temp3 = 0;
            for (i=0;i<40;i++)
			{
				temp3 += w->srednia_200ms_[i];//wyliczanie calki za czas od 8-16s;
				if (w->srednia_200ms_[temp] < log->Ubl_) OK = 0;
			}
            temp2 += temp3 / 2;
            //doliczenie calki za czesc czasu z zakresu powyzej 16s
            temp3 = 0;
            while(temp!=w->idx_400ms_)
            {
                temp++;
                if(temp>35) temp = 0;
                temp3 += w->srednia_400ms_[temp];
				if (w->srednia_400ms_[temp] < log->Ubl_) OK = 0;
            }
			if (log->zakres_ == od16do30_nieparzyste)
			{
				temp3 += w->srednia_400ms_[temp] / 2;
            	temp2 += temp3;
            	temp2 /= (float)(0.5 + 40 + log->ofset_); // calka za caly czas okna pomiarowego
			} else {
            	temp2 += temp3;
            	temp2 /= 40 + log->ofset_; // calka za caly czas okna pomiarowego
			}
            //
            break;
        }

	if (OK)
	{
		*log->esk_ptr = temp2 - log->Uwe;//przepisanie wyliczonej wartosci na wyjscie
		*log->ok_ptr|=(1<<log->ok_bit_no);
	}
	else
	{
		*log->esk_ptr = 0;
		*log->ok_ptr&=~(1<<log->ok_bit_no);
	}
}
